getwd()
.libPaths("E:/GmHapMap/Haplotypes/Chr01")
.libPaths()

install.packages(c("ggplot2", "LDcorSV", "Matrix", "reshape2", "methods", "stringr", "devtools"))

source("https://bioconductor.org/biocLite.R")

biocLite()

biocLite(c("GenomeInfoDb", "BiocGenerics", "snpStats", "SummarizedExperiment", "VariantAnnotation"))

#setwd("autohaplo") # répertoire contenant le code du package

devtools::install()


library(autohaplo)
library(snpStats)
library(VariantAnnotation)
library(ggplot2)
library(reshape2)
library(LDcorSV)
library(GenomeInfoDb)

options(max.print = 1e7)

markers <- read_hapmap("REF_01.hmp.txt")
genes <- read.table("gene.db.txt", header = TRUE, stringsAsFactors = FALSE)[[1]]

graph_list <- list("All_markers" = "density",
                   "Filtered_markers" = c("matrix", "distance", "genotypes"),
                   "Clustered_markers" = c("matrix", "genotypes"),
                   "Selected_clusters" = c("matrix", "genotypes"),
                   "Selected_markers" = c("matrix", "genotypes"),
                   "Haplotypes" = c("genotypes"))

for(i in genes[1:2145]) {
  # Storing the parameters of the analysis in an object
  message("Analyzing gene ", i)
  params <- haplo_params(file_format = "hapmap",
                         structure_file = "structure_Chr01",
                         kinship_file = NULL,
                         gene_db_file = "gene.db.txt",
                         chr_db_file = "gmax.chr.sizes.txt",
                         gene_name = i,
                         R2_measure = "r2",
                         cluster_R2 = "r2",
                         max_missing_threshold = 0.05,
                         max_het_threshold = 0.01,
                         min_alt_threshold = NULL,
                         min_allele_count = 4,
                         cluster_threshold = 0.9,
                         max_flanking_pair_distance = 10000,
                         max_marker_to_gene_distance = 6000,
                         marker_independence_threshold = 0.8)

  results <- haplo_selection(params, snp_data = markers)

  if(!is.na(results$Haplotypes)) {
    autohaplo_output(results, output_dir = i, graphs = graph_list)
  } else {
    dir.create(paste0("failed", i))
  }

}

